--Best = 

local M = {}

local helper = require('scenario/scenariohelper')
local file = require('scenario/fileHandler')
local powerupHelper = require('scenario/powerup')

local scenarioTimeOut = 0
local timeOutLimit = 5
local multiplier = 1
local startTimer = false
local reset = true
local powers = {false, false, false, false, false, false}

local function success(score, team, opponent, multi)
	local medal, nextMedal
	if score < 100 then 
		medal = 'None'
		nextMedal = 'Bronze(100)'
	elseif score >= 100 and score < 800 then 
		medal = 'Bronze'
		nextMedal = 'Silver(800)'
	elseif score >= 800 and score < 7000 then 
		medal = 'Silver'
		nextMedal = 'Gold(7000)'
	elseif score >= 7000 and score < 34000 then 
		medal = 'Gold'
		nextMedal = 'Platinum(34000)'
	elseif score >= 34000 and score < 81000 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(81000)'
	elseif score >= 81000 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end

	file.updateFile(file.getMedalAsNumber(medal), 22, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: (('..team..'- '..opponent..')*'..multi..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'ice' and (data.subjectName == 'player' or data.subjectName == 'truck') then
		helper.queueLuaCommandByName('player', 'bullettime.set(4)')
		if data.subjectName == 'player' then startTimer = true
		elseif powers[5] then
			local truck = scenetree.findObject('truck')
			truck:queueLuaCommand('obj:setWind(0, 0, 0)')
		elseif powers[6] then
			local truck = scenetree.findObject('truck') --2
			truck:queueLuaCommand('obj:setWind(0, 0, 0)')
		end
	end
end

local function checkPowerups(vehicleObject)
	if not powers[1] and powerupHelper.checkDistance(vehicleObject, 577.706238, 732.667053, 2.03013372, 3) then 
		powerupHelper.triggerMultiplier('x4', 0)
		powers[1] = true
		multiplier = multiplier*4
	end
	if not powers[2] and powerupHelper.checkDistance(vehicleObject, 570.398926, 724.484558, 6.0736165, 3) then
		powerupHelper.triggerMultiplier('x8', 1)
		powers[2] = true
		multiplier = multiplier*8
	end
	if not powers[3] and powerupHelper.checkDistance(vehicleObject, 552.247437, 723.969727, 5.56424236, 3) then
		powerupHelper.triggerMultiplier('x8', 2)
		powers[3] = true
		multiplier = multiplier*8
	end
	if not powers[4] and powerupHelper.checkDistance(vehicleObject, 562.888794, 733.32782, 30.0839558, 3) then
		powerupHelper.triggerMultiplier('x8', 3)
		powers[4] = true
		multiplier = multiplier*8
	end
	
	if not powers[5] and powerupHelper.checkDistance(vehicleObject, 562.682983, 747.991455, 1.94404721, 3) then
		powerupHelper.triggerMultiplier('juggernaut', 1)
		powers[5] = true
		--Find truck
		local truck = scenetree.findObject('truck')
		--Apply acceleration to it
		truck2:queueLuaCommand('obj:setWind(0, 300, 0)')
	end
	if not powers[6] and powerupHelper.checkDistance(vehicleObject, 553.809814, 732.598938, 1.94404721, 3) then
		powerupHelper.triggerMultiplier('juggernaut', 2)
		powers[6] = true
		--Find truck
		local truck2 = scenetree.findObject('truck') --2
		--Apply acceleration to it
		truck2:queueLuaCommand('obj:setWind(0, 300, 0)')
	end
end


local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			x4_board.position = "-577.706238 -732.667053 2.03013372";
			x8_1_board.position = "-570.398926 -724.484558 6.0736165";
			x8_2_board.position = "-552.247437 -723.969727 5.56424236";
			x8_3_board.position = "-562.888794 -733.32782 30.0839558";
			juggernaut_1_board.position = "-562.682983 -747.991455 1.94404721";
			juggernaut_2_board.position = "-553.809814 -732.598938 1.94404721";
		]])
		reset = false
	end
	
	checkPowerups(scenetree.findObject('player'))
	checkPowerups(scenetree.findObject('opponent1'))
	checkPowerups(scenetree.findObject('opponent2'))
	checkPowerups(scenetree.findObject('opponent3'))
	checkPowerups(scenetree.findObject('opponent4'))
	--checkPowerups(scenetree.findObject('truck1'))
end

local function finish()
	local playerObject = scenetree.findObject('player')
    local carOpponentObject = scenetree.findObject('opponent1')	
	local carOpponentObject2 = scenetree.findObject('opponent2')	
	local carOpponentObject3 = scenetree.findObject('opponent3')	
	local carOpponentObject4 = scenetree.findObject('opponent4')	
	local distance = math.floor(math.sqrt(math.pow(playerObject:getPosition().x+563.3, 2) + math.pow(playerObject:getPosition().y+733.6, 2), math.pow(playerObject:getPosition().z+0.01, 2)))
	local distanceOpponent1 = math.floor(math.sqrt(math.pow(carOpponentObject:getPosition().x+563.3, 2) + math.pow(carOpponentObject:getPosition().y+733.6, 2), math.pow(carOpponentObject:getPosition().z+0.01, 2)))
	local distanceOpponent2 = math.floor(math.sqrt(math.pow(carOpponentObject2:getPosition().x+563.3, 2) + math.pow(carOpponentObject2:getPosition().y+733.6, 2), math.pow(carOpponentObject2:getPosition().z+0.01, 2)))
	local distanceOpponent3 = math.floor(math.sqrt(math.pow(carOpponentObject3:getPosition().x+563.3, 2) + math.pow(carOpponentObject3:getPosition().y+733.6, 2), math.pow(carOpponentObject3:getPosition().z+0.01, 2)))
	local distanceOpponent4 = math.floor(math.sqrt(math.pow(carOpponentObject4:getPosition().x+563.3, 2) + math.pow(carOpponentObject4:getPosition().y+733.6, 2), math.pow(carOpponentObject4:getPosition().z+0.01, 2)))

	local scorePlayer = 100-distance
	local scoreOpponent1 = 100-distanceOpponent1
	local scoreOpponent2 = 100-distanceOpponent2
	local scoreOpponent3 = 100-distanceOpponent3
	local scoreOpponent4 = 100-distanceOpponent4

	local scoreFinal = (scorePlayer-scoreOpponent1-scoreOpponent2-scoreOpponent3-scoreOpponent4)*multiplier
	success(scoreFinal, scorePlayer, scoreOpponent1+scoreOpponent2+scoreOpponent3+scoreOpponent4, multiplier)
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	if startTimer then
		scenarioTimeOut = scenarioTimeOut+raceTickTime
		playerObject:queueLuaCommand('obj:setWind(0, 0, 0)')
		local test = scenetree.findObject('x4_board')
		print(test:getPosition().x)
	else 
		playerObject:queueLuaCommand('obj:setWind(0, 200, 0)')
	end

	if scenarioTimeOut >= timeOutLimit then 
		if timeOutLimit == 5 then
			timeOutLimit = 10
			helper.queueLuaCommandByName('player', 'bullettime.set(1)')
			if not powers[4] then finish()
			else scenarioTimeOut = 0
			end
		else
			finish()
		end
	end
end

M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onPreRender = onPreRender
return M